var gulp          = require('gulp'),
    rename        = require('gulp-rename'),
    svgSprite     = require('gulp-svg-sprite'),
    elixir        = require('laravel-elixir'),
    notifications = require('laravel-elixir/ingredients/commands/Notification'),
    utilities     = require('laravel-elixir/ingredients/commands/Utilities'),
    _             = require('underscore');

elixir.extend('svgSprite', function(options) {

    var config = this,
        defaultOptions = {
            outputDir: 'public/svg',
            rename: 'svg-include',
            srcDir: 'resources/svg'
        };

    options = _.extend(defaultOptions, options);

    gulp.task('svgSprite', function() {
        var onError = function(e) {
            new notifications().error(e, 'SVG Sprite sprite sheet creation failed');
            this.emit('end');
        };

        return gulp.src(options.srcDir + '/**/*.svg')
            .pipe(svgSprite(options))
            .on('error', onError)
            .pipe(rename({ basename: options.rename }))
            .pipe(gulp.dest(options.outputDir))
            .pipe(new notifications().message('SVG Sprite sprite sheet created on ' + options.outputDir));
    });

    this.registerWatcher('svgSprite', options.srcDir + '/**/*.svg');

    return this.queueTask('svgSprite');
});
